module.exports = function(db) {
	var dao = {};
	var W = require('when');

    //Fa un require de tots els fitxers .js de la carpeta dao
    require('fs').readdirSync(__dirname + '/').forEach(function(file) {
        if (file.match(/.+\.js/g) !== null && file !== 'index.js') {
            var name = file.replace('.js', '');
            dao[name.charAt(0).toUpperCase() + name.substr(1)] = require('./' + name)(db);
        }
    });

    dao.create = function(Model, data,t) {
        var df = W.defer();
        Model.create(data, {transaction: t})
            .success(df.resolve).error(df.reject);
        return df.promise;
    };

    dao.deleteById = function(Model, id,t) {
        var df = W.defer();
        Model.find({where: {id: id}, transaction: t})
            .success(function(model){
                if(model!=null) {
                    model.destroy()
                        .success(df.resolve)
                        .error(df.reject)
                }else df.reject();
            })
            .error(df.reject);
        return df.promise;
    };

    dao.updateById = function(Model, id, data,t) {
        var df = W.defer();
        Model.find({where: {id: id}, transaction: t})
            .success(function(model){
                model.updateAttributes(data)
                    .success(df.resolve)
                    .error(df.reject)
            })
            .error(df.reject);
        return df.promise;
    };

    dao.updateAttributes = function(Model, data) {
        var df = W.defer();
        Model.updateAttributes(data)
                    .success(df.resolve)
                    .error(df.reject)
        return df.promise;
    };

    dao.getById = function(Model, id, t) {
        var df = W.defer();
        Model.find({where: {id: id}, transaction: t}).success(df.resolve).error(df.reject);
        return df.promise;
    };

    dao.getByIdAttributes = function(Model,attribs, id, t) {
        var df = W.defer();
        Model.find({where: {id: id},attributes:attribs, transaction: t}).success(df.resolve).error(df.reject);
        return df.promise;
    };

    dao.getByWhere= function(Model, where, t) {
        var df = W.defer();
        Model.findAll({where: where, transaction: t}).success(df.resolve).error(df.reject);
        return df.promise;
    };

    dao.findAll = function(Model, where, t){
        var df = W.defer();
        Model.findAll({where: where,transaction:t}).success(df.resolve).error(df.reject);
        return df.promise;
    }

    dao.findAllWhereInclude = function(Model,where,include, t){
        var df = W.defer();
        Model.findAll({where: where, include:include,  transaction: t}).success(df.resolve).error(df.reject);
        return df.promise;
    }

	return dao;
};