define([
        'jquery', 'jquerycookie', 'underscore', 'backbone',
        'main2', 'alertify', 'jqueryfbp',
        'text!templates/company/logosTemplate.html',
        'models/company/LogoModel'
    ],
    function ($, cookie, _, Backbone, main, alertify, fb1, template, LogoModel) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");

                var that = this;

                that.collection = new LogoModel([]);
                that.collection.fetch({
                    success: function (collection, response) {
                        that.collection = response;
                        that.render();
                    },
                    error: function (collection, response) {
                        console.log(response);
                        console.log("ERROR");
                    } });
            },
            events: {
                "click .removeLogo": "removeLogo",
                "click .uploadLogo": "uploadLogo"},
            uploadLogo: function (e) {
                getTarget(e).disabled = true;
                getTarget(e).innerHTML = "Uploading...";
                e.preventDefault();

                var data = {
                    name: this.$("#name").val()
                };

                this.model = new LogoModel(data);

                var fileObject = $(':input[type="file"]')[0].files[0];
                console.log(fileObject);

                this.model.set('file', fileObject);
                var that = this;
                this.model.save({}, {
                    success: function (model, response) {
                        alertify.success("Logo uploaded!");
                        console.log(response);
                        that.collection.push(response);
                        that.render();
                    },
                    error: function (model, response) {
                        console.log(response);
                        console.log("ERROR");
                        var responseObj = $.parseJSON(response.responseText);
                        alertify.error(responseObj.error);
                        getTarget(e).disabled = false;
                        getTarget(e).innerHTML = "Upload logo";
                    }
                });
            },
            removeLogo: function (e) {
                e.preventDefault();
                var that = this;

                alertify.set({ labels: {
                    ok: "Yes",
                    cancel: "No"
                } });
                alertify.confirm("Are you sure?", function (ok) {
                    if (ok) {
                        var model = new LogoModel({id: getTarget(e).id});
                        model.destroy({
                            success: function (response) {
                                $(getTarget(e).parentNode).remove(); //Delete the logo
                                for (var i = 0; i < that.collection.length; i++) //Delete from array
                                    if (that.collection[i].id == response.id) {
                                        that.collection.splice(i, 1);
                                        break;
                                    }
                                alertify.success("Logo removed!");
                            },
                            error: function (response) {
                                console.log(response);
                                var responseObj = $.parseJSON(response.responseText);
                                alertify.error(responseObj.error);
                                getTarget(e).disabled = false;
                                getTarget(e).innerHTML = "Upload logo";
                            }
                        });
                    }
                });
            },
            render: function () {
                if (this.collection.length > 0) {
                    var data = {
                        photos: this.collection,
                        _: _
                    };
                }
                else var data = {photos: []};
                console.log(data);
                var compiledTemplate = _.template(template, data);
                $("#content").html(compiledTemplate);
                initMenuCompany("#menu-logos");
                $(".fancybox").fancybox(initFancyBox);
                $("#name").focus();
            }
        });
    });