define([
        'jquery', 'jquerycookie','backbonemfu', 'underscore', 'backbone',
        'main2','alertify',
        'text!templates/company/productsAddTemplate.html',
        'models/company/ProductModel',
        'models/company/ProductImageModel',
        'views/company/CompanyProductsPhotosView'
    ],
    function ($, cookie, backbonemfu ,_, Backbone, main,alertify, template, ProductModel,ProductImageModel ,CompanyProductsPhotosView) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function (id) {
                $(this.el).unbind("click");
                window.id = id;

                var that = this;

                that.collection = new ProductModel({id: window.id});
                that.collection.fetch({
                    success: function (model, response) {
                        that.collection = response;
                        console.log(response)
                        that.render2();
                    },
                    error: function (model, response) {
                        console.log("ERROR");

                    }});
            },
            events: {"click .addProduct": "addProduct",
                    "click .removePhoto": "removePhoto",
                     "click .uploadPhoto": "uploadPhoto"},
            addProduct: function (e) {
                console.log("fu");
                getTarget(e).disabled = true;
                getTarget(e).innerHTML = "Updating...";
                e.preventDefault();

                var data = {
                    id: window.id,
                    name: this.$("#name").val(),
                    description: this.$("#description").val(),
                    t_description: this.$("#t_description").val(),
                    category: this.$("#category").val(),
                    coins: this.$("#coins").val(),
                    quantity: this.$("#quantity").val(),
                };

                this.model = new ProductModel(data);
                this.model.save({}, {
                    success: function (model, response) {
                        alertify.success("Product updated!");
                        getTarget(e).disabled = false;
                        getTarget(e).innerHTML = "Update";
                        //console.log(response);
                    },
                    error: function (model, response) {
                        console.log(response);
                        var responseObj = $.parseJSON(response.responseText);
                        alertify.error(responseObj.error);
                        getTarget(e).disabled = false;
                        getTarget(e).innerHTML = "Update";
                    }
                });
            },
            uploadPhoto: function (e) {
                getTarget(e).disabled = true;
                getTarget(e).innerHTML = "Updating...";
                e.preventDefault();

                var data = {
                    productid:this.collection[0].id
                };

                this.model = new ProductImageModel(data);

                var fileObject = $(':input[type="file"]')[0].files[0];
                console.log(fileObject);

                this.model.set('file', fileObject);

                this.model.save({}, {
                    success: function (model, response) {
                        console.log(response);
                        new CompanyProductsPhotosView(model.productid).render();
                        alertify.success("Photo uploaded!");
                    },
                    error: function (model, response) {
                        console.log(response);
                        var responseObj = $.parseJSON(response.responseText);
                        alertify.error(responseObj.error);
                        getTarget(e).disabled = false;
                        getTarget(e).innerHTML = "Update";
                    }
                });
            },
            removePhoto: function (e) {
                getTarget(e).disabled = true;
                e.preventDefault();

                this.model = new ProductImageModel({
                    productid:this.collection[0].id,
                    id: getTarget(e).id});
                this.model.destroy({
                    success: function (response) {
                        $(getTarget(e)).remove();
                        console.log(response);
                    },
                    error: function (response) {
                        $(getTarget(e)).remove();
                        console.log(response);
                        var responseObj = $.parseJSON(response.responseText);
                        alertify.error(responseObj.error);
                        getTarget(e).disabled = false;
                        getTarget(e).innerHTML = "Update";
                    }
                });
            },
            render2: function () {
                if (!$.cookie("photopotterAuth"))window.location = "/#company";
                else {
                    if (this.collection.length>0) {
                        var data = {
                            type: "Update",
                            product: this.collection[0],
                            _: _
                        };
                        var compiledTemplate = _.template(template, data);
                        $("#content").html(compiledTemplate);
                        $("#name").focus();
                        new CompanyProductsPhotosView(this.collection[0].id).render();
                    }
                    initMenuCompany("#menu-products");
                }
            }
        });
    });