define([
        'jquery', 'jquerycookie', 'underscore', 'backbone',
        'main2','alertify',
        'text!templates/company/baseTemplate.html',
        'models/company/ProductModel',
        'views/company/CompanyProductsListView'
    ],
    function ($, cookie, _, Backbone, main,alertify, template, ProductModel, CompanyProductsListView) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");

                var that = this;

                that.collection = new ProductModel([]);
                that.collection.fetch({
                    success: function (collection, response) {
                        console.log(response);
                        that.collection = response;
                        that.render();
                    },
                    error: function (collection, response) {
                        console.log("ERROR");
                    }});

            },
            events: {"click .deleteProduct": "onSubmit"},
            onSubmit: function (event) {
                event.preventDefault();

                alertify.set({ labels: {
                    ok     : "Yes",
                    cancel : "No"
                } });
                // confirm dialog
                alertify.confirm("Are you sure?", function (e) {
                    if (e) { //IF selects Yes
                        console.log(getTarget(event).parentNode.parentNode.parentNode)
                        var tr = getTarget(event).parentNode.parentNode.parentNode;
                        var model = new ProductModel({ id: tr.id});
                        model.destroy({
                            success: function (response) {
                                console.log(response);
                                var table = tr.parentNode;
                                table.removeChild(tr);
                                alertify.success("Product deleted!");
                            },
                            error: function (model, response) {
                                console.log(response);
                                console.log("ERROR");
                            }
                        });
                    }
                });
            },
            render: function () {
                if (!$.cookie("photopotterAuth"))window.location = "/#company";
                else {
                    $("#content").html(template);
                    initMenuCompany("#menu-products");
                    var products;
                    //Perque no carregui valors unknown
                    if (this.collection.length>0) products = new CompanyProductsListView({ collection: this.collection});
                    else products = new CompanyProductsListView({ collection: []});
                    products.render();
                }
            }
        });
    });
