define([
        'jquery', 'jquerycookie', 'underscore', 'backbone',
        'main2', 'alertify',
        'text!templates/company/registerTemplate.html',
        'models/company/CompanyModel'
    ],
    function ($, cookie, _, Backbone, main, alertify, template, CompanyModel) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");
            },
            events: {"click .register": "onSubmit"},
            onSubmit: function (e) {
                e.preventDefault();
                if (this.$("#password").val() != this.$("#password2").val()) alertify.error("Different passwords");
                else {
                    var data = {
                        name: this.$("#name").val(),
                        type: this.$("#type").val(),
                        street: this.$("#street").val(),
                        city: this.$("#city").val(),
                        country: this.$("#country").val(),
                        postcode: this.$("#postcode").val(),
                        email: this.$("#email").val(),
                        password: this.$("#password").val(),
                        passwordAdmin: this.$("#passwordAdmin").val()
                    };

                    this.model = new CompanyModel(data);
                    this.model.save({}, {
                        success: function (model, response) {
                            console.log(response);
                            alertify.success("Registration successful, Welcome to Photopotter");
                            $.cookie("photopotterAuth", true, { expires: 30 });
                            window.location = "/#company/home";
                        },
                        error: function (model, response) {
                            var responseObj = $.parseJSON(response.responseText);
                            alertify.error(responseObj.error);
                        }});
                }
            },
            render: function () {
                var data = {
                    type: "Register",
                    profile: [],
                    _: _
                };
                var compiledTemplate = _.template(template, data);
                $("#content").html(compiledTemplate);
                $("#name").focus();
                clearMenu();
            }
        });
    });
