define([
        'jquery',
        'underscore',
        'backbone',
        'main2', 'alertify',
        'text!templates/shop/basketTemplate.html',
        'models/user/UserModel',
        'models/shop/ShopBasketLineModel',
        'views/shop/ShopBasketSubView',
        'views/user/UserVisualsFriendsSubView'
    ],
    function ($, _, Backbone, main, alertify, template, UserModel, ShopBasketLineModel, ShopBasketSubView, UserVisualsFriendsSubView) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                var that = this;
                that.total = 0;
                $(this.el).unbind("click");
                var that = this;
                FB.getLoginStatus(function (response) {
                    if (response.status === 'connected') {
                        that.basketline = new ShopBasketLineModel({userID: response.authResponse.accessToken });
                        that.basketline.fetch({
                            success: function (model, response) {
                                console.log(response);

                                for (var i = 0; i < response.length; i++)
                                    that.total += response[i].quantity * response[i].product2.coins;
                                that.collection = response;
                                that.render2();
                            },
                            error: function (model, response) {
                                console.log("ERROR");
                                console.log(response);
                            }});
                    }
                    else window.location = "/";
                });
            },
            events: {"click .proceed": "proceed",
                "click .remove": "remove"},
            remove: function (e) {
                e.preventDefault();
                console.log(getTarget(e).id)
                var that = this;
                FB.getLoginStatus(function (response) {
                    if (response.status === 'connected') {
                        alertify.set({ labels: {
                            ok: "Yes",
                            cancel: "No"
                        } });
                        alertify.confirm("Are you sure?", function (event) {
                            if (event) {
                                var basketline = new ShopBasketLineModel({id: getTarget(e).id, userID: response.authResponse.accessToken });
                                basketline.destroy({
                                    success: function (model, response) {
                                        that.initialize();
                                    },
                                    error: function (model, response) {
                                        console.log("ERROR");
                                        console.log(response);
                                    }});
                            }
                        });
                    }
                    else window.location = "/";
                });
            },
            proceed: function (e) {

                e.preventDefault();
                var that = this;
                FB.getLoginStatus(function (response) {
                    if (response.status === 'connected') {

                        that.basket = new Backbone.Model([]);
                        that.basket.save({},{
                            url: "/user/" + response.authResponse.accessToken + "/proceed",
                            success: function (model, response) {
                                console.log(response);
                                alertify.success("Transaction complete. \nBe attentive to the day of delivery");
                                window.location = "#shop";
                            },
                            error: function (model, response) {
                                console.log("ERROR");
                                var responseObj = $.parseJSON(response.responseText);
                                alertify.error(responseObj.error);
                            }});
                    }
                    else window.location = "/";
                });
            },
            render: function () {
                new ShopBasketSubView();
                new UserVisualsFriendsSubView();
                initMenuUser("#menu-shop");
            },
            render2: function () {
                if (this.collection[0]) {
                    var data = {
                        products: this.collection,
                        total: this.total,
                        _: _
                    };
                }
                else var data = {products: [], total: 0};
                var compiledTemplate = _.template(template, data);
                $("#content").html(compiledTemplate);
                new ShopBasketSubView();
                new UserVisualsFriendsSubView();
                initMenuUser("#menu-shop");
            }
        });
    });